import textwrap
from io import StringIO

import pytest

from qosagg.codegen.minizinc_generator import MiniZincGenerator, MiniZincGeneratorConfig
from qosagg.domain.aggregation import Aggregation
from qosagg.domain.attribute import Attribute
from qosagg.domain.graph import CompositeGraph, GraphComposition, LoopedGraph, Task
from qosagg.domain.provision import Provision, AttributeValue
from qosagg.domain.unrolling.unrolled_graph import unroll
from qosagg.domain.workflow import NamedWorkflow
from qosagg.user_input_error import UserInputError
from tests.helpers import ssg


@pytest.fixture
def config() -> MiniZincGeneratorConfig:
    return MiniZincGeneratorConfig(output=False, checkpoints=False, reachability=False)


def test_generate(config, output: StringIO) -> None:
    # given a simple valid workflow
    workflow = NamedWorkflow("wf1", unroll(CompositeGraph(
        [ssg("A"), ssg("B"), ssg("C")],
        GraphComposition.SEQUENTIAL, "s")),
                             [
                                 Provision("p1", {Task("A"), Task("B")}, {
                                     AttributeValue("latency", "2.1"),
                                     AttributeValue("cost", "3")
                                 }),
                                 Provision("p2", {Task("B"), Task("C")}, {
                                     AttributeValue("latency", "-2"),
                                     AttributeValue("cost", "0")
                                 })
                             ], [Aggregation("latency", "sum", "max"),
                                 Aggregation("cost", "sum", "sum")],
                             [], [Attribute("cost", "int")])

    # when generating MiniZinc code for it
    MiniZincGenerator(workflow, output, config).generate()

    # then the generated text should match what we expect
    actual = output.getvalue()
    print(actual)
    assert actual == textwrap.dedent("""\
        % code generated by QosAgg for workflow wf1
        
        % declarations
        enum WF1_PROVISION = { wf1_p1, wf1_p2 };
        enum WF1_TASK = { wf1_A, wf1_B, wf1_C };
        enum WF1_TASK_INST = { wf1_A_inst, wf1_B_inst, wf1_C_inst };
        array[WF1_TASK_INST] of WF1_TASK: wf1_task_of_inst = [wf1_A, wf1_B, wf1_C];
        array[WF1_TASK_INST] of var WF1_PROVISION: wf1_selection;
        set of WF1_PROVISION: wf1_A_provisions = { wf1_p1 };
        set of WF1_PROVISION: wf1_B_provisions = { wf1_p1, wf1_p2 };
        set of WF1_PROVISION: wf1_C_provisions = { wf1_p2 };
        
        % attribute assignments
        array[WF1_PROVISION] of int: wf1_cost = [3, 0];
        array[WF1_PROVISION] of float: wf1_latency = [2.1, -2];
        
        % selection attributes
        var int: wf1_A_cost = wf1_cost[wf1_selection[wf1_A_inst]];
        var float: wf1_A_latency = wf1_latency[wf1_selection[wf1_A_inst]];
        var int: wf1_B_cost = wf1_cost[wf1_selection[wf1_B_inst]];
        var float: wf1_B_latency = wf1_latency[wf1_selection[wf1_B_inst]];
        var int: wf1_C_cost = wf1_cost[wf1_selection[wf1_C_inst]];
        var float: wf1_C_latency = wf1_latency[wf1_selection[wf1_C_inst]];
        
        % aggregations
        var int: wf1_aggregated_cost = sum([wf1_A_cost, wf1_B_cost, wf1_C_cost]);
        var float: wf1_aggregated_latency = sum([wf1_A_latency, wf1_B_latency, wf1_C_latency]);
        
        % constraints
        constraint wf1_selection[wf1_A_inst] in wf1_A_provisions;
        constraint wf1_selection[wf1_B_inst] in wf1_B_provisions;
        constraint wf1_selection[wf1_C_inst] in wf1_C_provisions;
        """)  # noqa: W293, E501


def test_choices(config, output: StringIO) -> None:
    # given a valid workflow with twa choices: (A + B) | (C + D)
    # noinspection DuplicatedCode
    workflow = NamedWorkflow("wf1", unroll(CompositeGraph([
        CompositeGraph([ssg("A"), ssg("B")], GraphComposition.CHOICE, "choice1"),
        CompositeGraph([ssg("C"), ssg("D")], GraphComposition.CHOICE, "choice2"),
    ], GraphComposition.SEQUENTIAL, "c3")),
                             [
                                 Provision("p1", {Task("A"), Task("B"), Task("C"), Task("D")}, {
                                     AttributeValue("cost", "1.0")
                                 }),
                                 Provision("p2", {Task("A"), Task("B"), Task("C"), Task("D")}, {
                                     AttributeValue("cost", "2")
                                 })
                             ], [Aggregation("cost", "sum", "sum")], [], [])

    # when generating the MiniZinc code
    MiniZincGenerator(workflow, output, config).generate()

    # then the generator should have generated two separate choice decision variables
    actual = output.getvalue()
    expectation = textwrap.dedent("""\
            % code generated by QosAgg for workflow wf1
            
            % declarations
            enum WF1_PROVISION = { wf1_p1, wf1_p2 };
            enum WF1_TASK = { wf1_A, wf1_B, wf1_C, wf1_D };
            enum WF1_TASK_INST = { wf1_A_inst, wf1_B_inst, wf1_C_inst, wf1_D_inst };
            array[WF1_TASK_INST] of WF1_TASK: wf1_task_of_inst = [wf1_A, wf1_B, wf1_C, wf1_D];
            array[WF1_TASK_INST] of var WF1_PROVISION: wf1_selection;
            set of WF1_PROVISION: wf1_A_provisions = { wf1_p1, wf1_p2 };
            set of WF1_PROVISION: wf1_B_provisions = { wf1_p1, wf1_p2 };
            set of WF1_PROVISION: wf1_C_provisions = { wf1_p1, wf1_p2 };
            set of WF1_PROVISION: wf1_D_provisions = { wf1_p1, wf1_p2 };
            var 1..2: wf1_choice1;
            var 1..2: wf1_choice2;
            array[1..1] of var 1..2: wf1_choice1_insts = [wf1_choice1];
            array[1..1] of var 1..2: wf1_choice2_insts = [wf1_choice2];
            
            % attribute assignments
            array[WF1_PROVISION] of float: wf1_cost = [1.0, 2];
            
            % selection attributes
            var float: wf1_A_cost = wf1_cost[wf1_selection[wf1_A_inst]];
            var float: wf1_B_cost = wf1_cost[wf1_selection[wf1_B_inst]];
            var float: wf1_C_cost = wf1_cost[wf1_selection[wf1_C_inst]];
            var float: wf1_D_cost = wf1_cost[wf1_selection[wf1_D_inst]];
            
            % aggregations
            var float: wf1_aggregated_cost = sum([[wf1_A_cost, wf1_B_cost][wf1_choice1], [wf1_C_cost, wf1_D_cost][wf1_choice2]]);
            
            % constraints
            constraint wf1_selection[wf1_A_inst] in wf1_A_provisions;
            constraint wf1_selection[wf1_B_inst] in wf1_B_provisions;
            constraint wf1_selection[wf1_C_inst] in wf1_C_provisions;
            constraint wf1_selection[wf1_D_inst] in wf1_D_provisions;
            """)  # noqa: W293, E501
    assert actual == expectation


def test_loop_aggregation(config, output: StringIO) -> None:
    # given a looped workflow A^4
    workflow = NamedWorkflow("wf", unroll(LoopedGraph(ssg("A"), 4, "l1")), [], [
        Aggregation("cost", "sum", "foobar")
    ], [], [Attribute("cost", "int")])

    # when generating the MiniZinc code
    MiniZincGenerator(workflow, output, config).generate()

    # then the output should contain a proper aggregation for cost
    expectation = textwrap.dedent("""\
        var int: wf_aggregated_cost = sum([wf_A_cost_1, wf_A_cost_2, wf_A_cost_3, wf_A_cost_4]);
        """).strip()
    actual = output.getvalue()
    print(actual)
    assert expectation in actual


def test_choice_in_loop_aggregation(config, output: StringIO) -> None:
    # given a looped workflow (A+B)^4
    workflow = NamedWorkflow("wf",
                             unroll(LoopedGraph(
                                 CompositeGraph([ssg("A"), ssg("B")],
                                                GraphComposition.CHOICE, "choice1"),
                                 4, "l1")),
                             [], [
                                 Aggregation("cost", "sum", "foobar")
                             ], [], [Attribute("cost", "int")])

    # when generating the MiniZinc code
    MiniZincGenerator(workflow, output, config).generate()

    # then the output should contain a proper aggregation for cost
    expectation = textwrap.dedent("""\
        var int: wf_aggregated_cost = sum([[wf_A_cost_1, wf_B_cost_1][wf_choice1_1], [wf_A_cost_2, wf_B_cost_2][wf_choice1_2], [wf_A_cost_3, wf_B_cost_3][wf_choice1_3], [wf_A_cost_4, wf_B_cost_4][wf_choice1_4]]);
        """).strip()  # noqa: E501
    actual = output.getvalue()
    assert expectation in actual


def test_nested_loops_aggregation(config, output: StringIO) -> None:
    # given a nested looped workflow (A^2 -> B^3)^2
    workflow = NamedWorkflow("wf",
                             unroll(LoopedGraph(
                                 CompositeGraph([
                                     LoopedGraph(ssg("A"), 2, "l2"),
                                     LoopedGraph(ssg("B"), 3, "l3")
                                 ], GraphComposition.SEQUENTIAL, "s1"), 2, "l1")),
                             [], [
                                 Aggregation("cost", "sum", "foobar")
                             ], [], [])

    # when generating the MiniZinc code
    MiniZincGenerator(workflow, output, config).generate()

    # then the output should contain a proper aggregation for cost
    expectation = textwrap.dedent("""\
        var float: wf_aggregated_cost = sum([sum([sum([wf_A_cost_1_1, wf_A_cost_1_2]), sum([wf_B_cost_1_1, wf_B_cost_1_2, wf_B_cost_1_3])]), sum([sum([wf_A_cost_2_1, wf_A_cost_2_2]), sum([wf_B_cost_2_1, wf_B_cost_2_2, wf_B_cost_2_3])])]);
        """).strip()  # noqa: E501
    actual = output.getvalue()
    assert expectation in actual


def test_task_inst_task_map_generation(config, output: StringIO) -> None:
    # given a nested looped workflow (A^2 | B)^2 -> C
    workflow = NamedWorkflow("wf", unroll(CompositeGraph(
        [
            LoopedGraph(CompositeGraph([
                LoopedGraph(ssg("A"), 2, "l2"),
                ssg("B")
            ], GraphComposition.PARALLEL, "p1"), 2, "l1"),
            ssg("C")
        ], GraphComposition.SEQUENTIAL, "s1"
    )), [], [], [], [])

    # when generating the code
    MiniZincGenerator(workflow, output, config).generate()

    # then the output should contain the mapping from task instances to tasks
    task_insts_exp = textwrap.dedent("""\
        enum WF_TASK_INST = { wf_A_inst_1_1, wf_A_inst_1_2, wf_A_inst_2_1, wf_A_inst_2_2, wf_B_inst_1, wf_B_inst_2, wf_C_inst };
        """).strip()  # noqa: E501
    mapping_exp = textwrap.dedent("""\
        array[WF_TASK_INST] of WF_TASK: wf_task_of_inst = [wf_A, wf_A, wf_A, wf_A, wf_B, wf_B, wf_C];
    """).strip()
    actual = output.getvalue()
    print(actual)
    assert task_insts_exp in actual
    assert mapping_exp in actual


def test_looped_choice_sets(output: StringIO, config) -> None:
    # given two looped choices: (A + (B + C)^2)^2
    wf = NamedWorkflow("wf", unroll(LoopedGraph(
        CompositeGraph([
            ssg("A"),
            LoopedGraph(CompositeGraph([
                ssg("B"),
                ssg("C")
            ], GraphComposition.CHOICE, "c2"), 2, "l2")
        ], GraphComposition.CHOICE, "c1"), 2, "l1")), [], [], [], [])

    # when generating the code for it
    MiniZincGenerator(wf, output, config).generate()

    # then the output should contain the correct choice sets
    exp = textwrap.dedent("""\
        var 1..2: wf_c1_1;
        var 1..2: wf_c2_1_1;
        var 1..2: wf_c2_1_2;
        var 1..2: wf_c1_2;
        var 1..2: wf_c2_2_1;
        var 1..2: wf_c2_2_2;
        array[1..2] of var 1..2: wf_c1_insts = [wf_c1_1, wf_c1_2];
        array[1..4] of var 1..2: wf_c2_insts = [wf_c2_1_1, wf_c2_1_2, wf_c2_2_1, wf_c2_2_2];
        """)
    actual = output.getvalue()
    print(actual)
    assert exp in actual


def test_task_task_inst_mapping(output: StringIO, config) -> None:
    # given a wf with two loops: A -> (B + C^3)^2
    wf = NamedWorkflow("wf", unroll(CompositeGraph([
        ssg("A"),
        LoopedGraph(CompositeGraph([
            ssg("B"),
            LoopedGraph(ssg("C"), 3, "l2")
        ], GraphComposition.CHOICE, "c1"), 2, "l1")
    ], GraphComposition.SEQUENTIAL, "s1"), ()), [], [], [], [])

    # when generating the code for it
    config.taskinst_mapping = True
    MiniZincGenerator(wf, output, config).generate()

    # then the output should contain mappings from task+iteration to task instances
    actual = output.getvalue()
    print(actual)
    assert "wf_A_insts" not in actual
    exp_b = "array[1..2] of WF_TASK_INST: wf_B_insts = array1d(1..2, [wf_B_inst_1, wf_B_inst_2]);"
    exp_c = "array[1..2, 1..3] of WF_TASK_INST: wf_C_insts = array2d(1..2, 1..3, [wf_C_inst_1_1, wf_C_inst_1_2, " \
            "wf_C_inst_1_3, wf_C_inst_2_1, wf_C_inst_2_2, wf_C_inst_2_3]);"
    assert exp_b in actual
    assert exp_c in actual


def test_no_task_task_inst_mapping_dim7(output: StringIO, config) -> None:
    # given a wf with loops nested 7 levels deep down
    wf = NamedWorkflow("wf", unroll(
        LoopedGraph(
            LoopedGraph(
                LoopedGraph(
                    LoopedGraph(
                        LoopedGraph(
                            LoopedGraph(
                                LoopedGraph(ssg("A"), 2, "l7"), 2, "l6"),
                            2, "l5"),
                        2, "l4"),
                    2, "l3"),
                2, "l2"),
            2, "l1")),
                       [], [], [], [])

    # when generating the code for it
    config.taskinst_mapping = True
    MiniZincGenerator(wf, output, config).generate()

    # then the output should not contain the mapping
    actual = output.getvalue()
    print(actual)
    assert "wf_A_insts" not in actual


def test_attribute_value_missing(output: StringIO, config) -> None:
    # given a simple workflow with a provision lacking an attribute value
    wf = NamedWorkflow("wf", unroll(ssg("A"), ()), [
        Provision("p1", {Task("A")}, {AttributeValue("barfoo", "3")}),
        Provision("p1", {Task("A")}, {AttributeValue("foobar", "3")})
    ], [], [], [Attribute("barfoo", "float")])

    # when generating the code for it, there should be an error
    with pytest.raises(UserInputError):
        MiniZincGenerator(wf, output, config).generate()


def test_default_value(config, output: StringIO) -> None:
    # given a workflow with three sequential tasks: A → B → C
    workflow = NamedWorkflow("wf1", unroll(CompositeGraph([
        ssg("A"), ssg("B"), ssg("C")
    ], GraphComposition.SEQUENTIAL, "c1")),
                             [
                                 Provision("p1", {Task("A")}, {AttributeValue("cost", "3.0")}),
                                 Provision("p2", {Task("A"), Task("B")}, {AttributeValue("cost", "1.0")}),
                                 Provision("p3", {Task("C")}, set())
                             ], [], [], [Attribute("cost", "float", "1.0")])

    # when generating the MiniZinc code
    MiniZincGenerator(workflow, output, config).generate()

    # then the generator should have used the default of 1.0 for p3
    actual = output.getvalue()
    expectation = "array[WF1_PROVISION] of float: wf1_cost = [3.0, 1.0, 1.0];"
    assert expectation in actual
